<?php

class Profile {

    static function CheckActiveMe() {
        $checkmeActive = db::get('profiles', 'active', "`id`='" . session('id') . "'");
        if ($checkmeActive == '0') {
            self::ErrorMsg('پروفایل شما غیرفعال شده است. اجازه دیدن پروفایل کاربران را ندارید');
        }
    }

    static function ErrorMsg($text) {
        $mytext = $text ? $text : false;
        include('theme/microblog/profile.notfound.php');
        exit();
    }

    static function Cover($cover) {
        return is_file('theme/images/covers/' . $cover) ? '/theme/images/covers/' . $cover : '/theme/microblog/images/cover.jpg';
    }

    static function UserInMyBlackList($id) {
        $myid = session('id');
        $get = db::get('users', '`blacklist`', "`id` = '$myid'");
        $blacklist = json_decode($get[0], true);
        $blacklist = array_unique($blacklist);
        $blacklist = array_values($blacklist);

        return in_array($id, $blacklist) ? true : false;
    }

    static function MeInBlackList($blacklist) {
        $user_blacklist = json_decode($blacklist, true);
        $user_blacklist = array_values($user_blacklist);

        return in_array(session('id'), $user_blacklist) ? true : false;
    }

    static function MeInFollower($ProfileFollowers) {
        return in_array(session('id'), $ProfileFollowers) ? true : false;
    }

    static function Emoticons() {
        $query = db::query("SELECT `img`,`code` FROM {prefix}smilies");
        echo '{';
        while ($row = mysqli_fetch_array($query)) {
            echo '"' . $row['code'] . '": "/theme/images/smilies/' . $row['img'] . '",';
        }
        echo '}';
        mysqli_free_result($query);
    }

    static function IsMyFriend($array) {
        return in_array(session('id'), $array) ? true : false;
    }

    static function ShowResizedAvatar($id, $size = '100x100') {
        return '/avatars/' . $id . '/' . $size;
    }

    static function ShowAvatarPostSender($file, $sex) {
        $path = 'theme/images/avatars/';
        return self::ShowResizedAvatar(is_file($path . '/' . $file) ? $file : ($sex == '1' ? 'no_avatar_male.png' : 'no_avatar_female.jpg'));
    }

    static function ShowInfo($info) {
        if (mb_strlen($info, 'UTF-8') > 400) {
            return mb_substr($info, 0, 400, 'UTF-8') . '...';
        } else {
            return $info;
        }
    }

    static function AddLastView($array, $id) {
        $json = ArrayUnsetValue($array, session('id'));
        $json[] = session('id');
        $json = array_unique($json);
        $json = array_values($json);
        $json = json_encode($json);
        db::update('profiles', "`views`='$json'", "`id`='$id'");
    }

    static function ShowLastPosts($action) {
        global $usertype, $options;
        $users = array();
        $x = 1;
        $query = db::query("SELECT p.*, u.`name`,u.`type`,u.`gender`,pr.`avatar`,o.`id` AS online FROM {prefix}profile_posts p LEFT JOIN {prefix}users u ON u.`id` = p.`userid` LEFT JOIN {prefix}profiles pr ON pr.`id` = p.`userid` LEFT JOIN {prefix}onlines o ON o.`id` = p.`userid` ORDER BY `id` DESC LIMIT 0,48");
        while ($row = mysqli_fetch_array($query)) {
            if (in_array($row['userid'], $users)) {
                continue;
            }
            $avatar = self::ShowResizedAvatar(is_file('theme/images/avatars/' . $row['avatar']) ? $row['avatar'] : ($row['gender'] == '1' ? 'no_avatar_male.png' : 'no_avatar_female.jpg'));
            $on = $row['online'] ? 'on' : '';
            echo('<li class="list-group-item ' . $on . '" data-toggle="tooltip" data-placement="bottom" title="' . $row['name'] . ' - ' . $usertype[$row['type']]['title'] . '"><a target="_blank" href="/profile/' . $row['userid'] . '"><img src="' . $avatar . '"><span>' . $row['name'] . '</span></a></li>');
            $users[] = $row['userid'];
            if ($x == 12) {
                break;
            }
            $x++;
        }
        unset($users, $x);
        mysqli_free_result($query);
    }

    static function LDUserCount($profile, $location) {
        $count = array();
        $ldavatar = json_decode($profile[$location], true);
        $count['likes'] = count($ldavatar['likedusers']);
        $count['dislikes'] = count($ldavatar['dislikedusers']);
        return $count;
    }

    static function ShowUsers($action) {
        global $usertype, $options;

        if (count($action) == '0') {
            return;
        }
        if (!empty($action)) {
            $action = array_slice($action, -12, 12);
            $implode = implode(',', $action);

            $query = db::query("SELECT u.`name`,u.`id`,u.`type`,u.`gender`, p.`avatar`, o.`id` AS online FROM {prefix}users u LEFT JOIN {prefix}profiles p ON p.`id` = u.`id` LEFT JOIN {prefix}onlines o ON o.`id` = u.`id` WHERE u.`id` IN($implode) ORDER BY FIELD(u.`id`,$implode) DESC");
            while ($row = mysqli_fetch_array($query)) {
                $avatar = Profile::ShowResizedAvatar(is_file('theme/images/avatars/' . $row['avatar']) ? $row['avatar'] : ($row['gender'] == '1' ? 'no_avatar_male.png' : 'no_avatar_female.jpg'));
                $on = $row['online'] ? 'on' : '';
                echo('<li class="list-group-item ' . $on . '" data-toggle="tooltip" data-placement="bottom" title="' . $row['name'] . ' - ' . $usertype[$row['type']]['title'] . '"><a target="_blank" href="/profile/' . $row['id'] . '"><img src="' . $avatar . '"><span>' . $row['name'] . '</span></a></li>');
            }
            mysqli_free_result($query);
        }
    }

    static function Send2Friends($text) {
        global $usertype;

        $myid = session('id');
        $type = $usertype[session('type')]['icon'];
        $sex = session('gender') == '2' ? theme::url('theme/images/chat/chat.user_comment_w.png') : theme::url('theme/images/chat/chat.user_comment_m.png');
        $color = $usertype[session('type')]['color'];
        $textColor = session('color') == '000000' || !session('color') ? 'red' : '#' . session('color');
        $profile = '<a href="/profile/' . $myid . '" target="_blank" title="پروفایل"><img src="' . theme::url("theme/images/chat/chat.pr.png") . '" /></a>';

        $note = '<table dir="rtl" cellpadding="3" border="1" align="center">
						<tr><td><b>کاربر:</b></td><td><b><a href=javascript:void(0) onclick=changeUserEvent("privatwin_' . $myid . '")><font color=' . $color . '>' . session('name') . '</font></a></b> <img src="/' . $type . '"><img src="' . $sex . '"></td></tr>
						<tr><td><b>آدرس پروفايل:</b></td><td>' . $profile . '</td></tr>
						<tr><td><b>متن:</b></td><td><b><font color=green>' . $text . '</font></b></td></tr>
					</table><hr>';

        $myfriends = Users::get('friends', $myid);
        $myfriends = json_decode($myfriends, true);

        if (count($myfriends) == '0') {
            return;
        }
        $implode = implode(',', $myfriends);

        $query = db::query("SELECT o.`id`,o.`roomid`,p.`settings` FROM {prefix}onlines o LEFT JOIN {prefix}profiles p ON p.`id` = o.`id` WHERE o.`id` IN($implode)");
        while ($row = mysqli_fetch_array($query)) {
            $u_setting = json_decode($row['settings'], true);
            if ($u_setting['notification'] == '0') {
                continue;
            }
            db::insert('message', '`user`, `username`, `color`,`fontname`,`fontsize`, `room`, `text`, `date`, `to`, `into`, `type`', "'-1', '<center>SYSTEM [ <b><font color=red>گزارش پروفايل دوستان</font></b> ]</center>','000000',  '" . session('fontname') . "', '" . session('fontsize') . "', '" . $row['roomid'] . "', '" . $note . "', '" . time() . "', '" . $row['id'] . "', 'pm', '" . session('admin') . "'");
        }
        mysqli_free_result($query);
    }

    static function SendMessage($id, $text, $textColor) {
        global $usertype;

        $type = $usertype[session('type')]['icon'];
        $sex = session('gender') == '2' ? theme::url('theme/images/chat/chat.user_comment_w.png') : theme::url('theme/images/chat/chat.user_comment_m.png');
        $color = $usertype[session('type')]['color'];
        $profile = '<a href="/profile/' . session('id') . '" target="_blank" title="پروفایل"><img src="' . theme::url("theme/images/chat/chat.pr.png") . '" /></a>';

        $note = '<table cellpadding="3" dir="rtl" border="1" align="center">
					<tr><td><b>کاربر:</b></td><td><b><a href=javascript:void(0) onclick=changeUserEvent("privatwin_' . session('id') . '")><font color=' . $color . '>' . session('name') . '</font></a></b> <img src="/' . $type . '"><img src="' . $sex . '"></td></tr>
					<tr><td><b>متن:</b></td><td><b><font color=' . $textColor . '>' . $text . '</font></b></td></tr>
					<tr><td><b>آدرس پروفايل:</b></td><td>' . $profile . '</td></tr>
				</table><hr>';

        $user_s = mysqli_fetch_array(db::query("SELECT o.`roomid`,p.`settings` FROM {prefix}onlines o LEFT JOIN {prefix}profiles p ON p.`id` = o.`id` WHERE o.`id` = '$id'"));
        $u_setting = json_decode($user_s['settings'], true);
        if ($u_setting['notification'] == '1') {
            db::insert('message', '`user`, `username`, `color`,`fontname`,`fontsize`, `room`, `text`, `date`, `to`, `into`, `type`', "'-1', '<center>SYSTEM [ <b><font color=red>گزارش پروفایل شما</font></b> ]</center>','000000',  '" . session('fontname') . "', '" . session('fontsize') . "', '" . $user_s['roomid'] . "', '" . $note . "', '" . time() . "', '" . $id . "', 'pm', '" . session('admin') . "'");
        }
        mysqli_free_result($user_s);
    }

    static function Report2Admins($pid, $postid) {
        global $usertype;
        $myid = session('id');
        $type = $usertype[session('type')]['icon'];
        $sex = session('gender') == '2' ? theme::url('theme/images/chat/chat.user_comment_w.png') : theme::url('theme/images/chat/chat.user_comment_m.png');
        $color = $usertype[session('type')]['color'];
        //	$textColor = session('color') == '000000' || !session('color') ? 'red' : '#'.session('color');
        $profile = '<a href="/profile/' . $pid . '/' . $postid . '" target="_blank" title="کلیک کنید"><img src="' . theme::url("theme/images/chat/chat.pr.png") . '" /></a>';
        $note = '<table dir="rtl" cellpadding="3" border="1" align="center">
					<tr><td><b>ارسال کننده گزارش:</b></td><td><b><a href=javascript:void(0) onclick=changeUserEvent("privatwin_' . $myid . '")><font color=' . $color . '>' . session('name') . '</font></a></b> <img src="/' . $type . '"><img src="' . $sex . '"></td></tr>
					<tr><td><b>آدرس مستقیم مطلب:</b></td><td>' . $profile . '</td></tr>
					<tr><td><b>متن:</b></td><td><b><font color=red>مطلب مورد نظر مورد دارد</font></b></td></tr>
				</table><hr>';

        $query = db::query('SELECT `id`,`type`,`roomid` FROM {prefix}onlines WHERE `admin` IN(1,2,3,4,5,6)');
        while ($row = mysqli_fetch_array($query)) {
            db::insert('message', '`user`, `username`, `color`,`fontname`,`fontsize`, `room`, `text`, `date`, `to`, `into`, `type`', "'-1', '<center>SYSTEM [ <b><font color=red>ارسال گزارش پروفایل</font></b> ]</center>',
				 '000000',  '" . session('fontname') . "', '" . session('fontsize') . "', '" . $row['roomid'] . "', '" . $note . "', '" . time() . "', '" . $row['id'] . "', 'pm', '" . session('admin') . "'");
        }
        mysqli_free_result($query);
    }

    static function UserSetting($action, $friends) {
        switch ($action) {
            case 'friends':
                $bool = self::IsMyFriend($friends);
                break;
            case 'all':
                $bool = true;
                break;
            case 'nothing':
                $bool = false;
                break;
            default:
                $bool = false;
                break;
        }
        return $bool;
    }

}

?>