<?php

if (!session('id') or session('admin') == '0') {
    exit();
}
adminpanel::check_Permission('exit', 'addvisualuser');

$token = isset($_POST['token']) ? $_POST['token'] : false;
if (!$token || $token != session('changepw')) {
    die('صفحه خود را رفرش نمایید .');
}

$name = isset($_POST['name']) ? safe::string($_POST['name']) : '';
if ($name == '') {
    echo('emptyname');
    return;
}
if (Users::Checkrunning($name)) {
    echo('running');
    return;
}

$gender = isset($_POST['gender']) ? safe::number($_POST['gender']) : '0';
if (!in_array($gender, array('0', '1', '2'))) {
    $gender = '0';
}

$type = isset($_POST['type']) ? (int) safe::number($_POST['type']) : 1;
if (!isset($usertype[$type])) {
    $type = $options['defaultusertype'];
}

$autoanswer = (isset($_POST['autoanswer']) and $_POST['autoanswer'] == 'true') ? true : false;
$status = isset($_POST['status']) ? safe::string($_POST['status']) : '';

$roomid = isset($_POST['room']) ? safe::number($_POST['room']) : chatroom::defaultRoom();
if (!chatroom::checkroomid($roomid)) {
    echo('roomid');
    return;
}
$roomname = chatroom::getNameRoom($roomid);

$user = Users::addUser($name, $name, $type, $gender);
Users::addOnline($user, $name, $name, $gender, $type, '0', $roomid, $roomname, true);
Users::Inputs($user, 'newvisualuser');


$inputs = json_decode(db::get('onlines', "inputs", "`id`='$user'"), true);
$inputs['autoanswer'] = $autoanswer;
$inputs['browser'] = safe::string($_POST['browser']);
if($status != ''){
$inputs['simg'] = 'status_notification';
$inputs['stext'] = Message::badwords($status);
}
$inputs['status_private'] = safe::string($_POST['status_private']);
$inputs['myOS'] = safe::string($_POST['myOS']);
$inputs['ubrowser'] = safe::string($_POST['ubrowser']);
$inputs = json_encode($inputs , JSON_UNESCAPED_UNICODE);
db::update('onlines', "`inputs`='$inputs'", "`id`='$user'");

$founded = false;

$query = db::query("SELECT `id`,`inputs` FROM {prefix}onlines WHERE `time`='0'");
while ($row = mysqli_fetch_array($query)) {
    $inputs = json_decode($row['inputs'], true);
    if (isset($inputs['autoanswer']) and $inputs['autoanswer'] == true) {
        if (db::num('autoanswer') > 0) {
            db::update('options', "`value`='1'", "`name`='autoanswer'");
            chatroom::reloadconfig();
        }
        $founded = true;

        break;
    }
}
mysqli_free_result($query);
if (!$founded) {
    db::update('options', "`value`='0'", "`name`='autoanswer'");
    chatroom::reloadconfig();
}


echo('ok');
?>
