<?php

header::tojson();
include('inc/classes/bbcode.php');
$limit = isset($options['main_numposts']) && $options['main_numposts'] > 0 ? $options['main_numposts'] : "5";
$lastime = isset($_POST['time']) ? safe::number($_POST['time']) : 0;
$myposts = myposts(0, $limit, $lastime);
echo json_encode(array('myposts' => (is_array($myposts) ? $myposts : array())), JSON_UNESCAPED_UNICODE);

function time_ago($time) {
    $etime = time() - $time;
    if ($etime < 1) {
        return 'هم اکنون';
    }
    $a = array(365 * 24 * 60 * 60 => 'year', 30 * 24 * 60 * 60 => 'month', 24 * 60 * 60 => 'day', 60 * 60 => 'hour', 60 => 'minute', 1 => 'second');
    $b = array('year' => 'سال', 'month' => 'ماه', 'day' => 'روز', 'hour' => 'ساعت', 'minute' => 'دقیقه', 'second' => 'ثانیه');
    foreach ($a as $secs => $str) {
        $d = $etime / $secs;
        if ($d >= 1) {
            return round($d) . ' ' . $b[$str] . ' قبل';
        }
    }
    return 'همین حالا';
}

function myposts($start = 0, $limit = 5, $lastime = 0) {
    global $usertype, $options;
    $profile = mysqli_fetch_array(db::query("SELECT u.`friends`,p.`followers` FROM `{prefix}users` u LEFT JOIN `{prefix}profiles` p ON p.`id` = u.`id` WHERE u.`id`='" . session('id') . "'", MYSQLI_ASSOC));
    $friends = array_values(json_decode($profile['friends'], true));
    $followers = json_decode($profile['followers'], true);
    $friends_posts = "";
    $follows_posts = "";
    $lasttime = $lastime != 0 ? " AND p.`time`>'{$lastime} '" : "";
    if (count($friends) != 0) {
        $ifriends = implode(",", $friends);
        $friends_posts = " OR p.`userid` IN({$ifriends})";
    }
    if (count($followers['me']) != 0) {
        $ifollowers = implode(",", $followers['me']);
        $follows_posts = " OR p.`userid` IN(P$ifollowers})";
    }
    mysqli_free_result($profile);
    $query = db::query("SELECT p.*, u.`name`,u.`type`,u.`gender`,pr.`avatar`,o.`id` AS online FROM `{prefix}profile_posts` p LEFT JOIN `{prefix}users` u ON u.`id`=p.`userid` LEFT JOIN `{prefix}profiles` pr ON pr.`id`=p.`userid` LEFT JOIN `{prefix}onlines` o ON o.`id`=p.`userid` WHERE (p.`userid`='" . session('id') . "' {$follows_posts} {$friends_posts}) {$lasttime} ORDER BY `id` DESC LIMIT {$start},{$limit}");
    $uposts = array();
    while ($row = mysqli_fetch_array($query, MYSQLI_ASSOC)) {
        $avatar = '/avatars/' . (is_file('theme/images/avatars/' . $row['avatar']) ? $row['avatar'] : ($row['gender'] == '1' ? 'no_avatar_male.png' : 'no_avatar_female.jpg')) . '/50x50';
        $for = "me";
        if (count($friends) != 0 and in_array($row['userid'], $friends)) {
            $for = "fr";
        }
        if (count($followers['me']) != 0 && in_array($row['userid'], $followers['me'])) {
            $for = "fl";
        }
        $uposts[] = array(
            'pid' => $row['id'],
            'id' => $row['userid'],
            'name' => $row['name'],
            'color' => $for,
            'avatar' => $avatar,
            'likes' => count(array_values(json_decode($row['likedusers'], true))),
            'dislikes' => count(array_values(json_decode($row['dislikedusers'], true))),
            'comments' => count(json_decode($row['comments'], true)),
            'content' => bbcode::tohtml($row['content'], true),
            'time' => time_ago($row['time']),
            'rtime' => $row['time']
        );
    }
    mysqli_free_result($query);
    return $uposts;
}
