<?php

header::tojson();
$lastposts = nlastposts();
$ufriends = nfriends();
echo json_encode(array('lastposts' => (is_array($lastposts) ? $lastposts : array()), 'friends' => (is_array($ufriends) ? $ufriends : array())), JSON_UNESCAPED_UNICODE);

function time_ago($time) {
    $etime = time() - $time;
    if ($etime < 1) {
        return 'هم اکنون';
    }
    $a = array(365 * 24 * 60 * 60 => 'year', 30 * 24 * 60 * 60 => 'month', 24 * 60 * 60 => 'day', 60 * 60 => 'hour', 60 => 'minute', 1 => 'second');
    $b = array('year' => 'سال', 'month' => 'ماه', 'day' => 'روز', 'hour' => 'ساعت', 'minute' => 'دقیقه', 'second' => 'ثانیه');
    foreach ($a as $secs => $str) {
        $d = $etime / $secs;
        if ($d >= 1) {
            return round($d) . ' ' . $b[$str] . ' قبل';
        }
    }
    return 'همین حالا';
}

function nfriends() {
    global $usertype, $options;
    $profile = mysqli_fetch_array(db::query("SELECT `friends` FROM `{prefix}users` WHERE `id`='" . session('id') . "'"), MYSQLI_ASSOC);
    $friends = json_decode($profile['friends'], true);
    $friends = array_values($friends);
    $ifriends = implode(",", $friends);
    $ufriends = array();
    if (count($friends) != 0) {
        $query = db::query("SELECT u.`name`,u.`id`,u.`type`,u.`gender`,p.`avatar` FROM `{prefix}users` u LEFT JOIN `{prefix}profiles` p ON p.`id`=u.`id` WHERE u.`id` IN({$ifriends}) ORDER BY FIELD(u.`id`,{$ifriends}) DESC");
        while ($row = mysqli_fetch_array($query)) {
            $avatar = '/avatars/' . (is_file('theme/images/avatars/' . $row['avatar']) ? $row['avatar'] : ($row['gender'] == '1' ? 'no_avatar_male.png' : 'no_avatar_female.jpg')) . '/100x100';
            $ufriends[] = array(
                'id' => $row['id'],
                'name' => $row['name'],
                'avatar' => $avatar,
                'icon' => $usertype[$row['type']]['icon'],
                'color' => $usertype[$row['type']]['color']
            );
        }
        mysqli_free_result($query);
        return $ufriends;
    }
    mysqli_free_result($profile);
}

function nlastposts() {
    global $usertype, $options;
    $users = array();
    $lastposts = array();
    $x = 1;
    $limit = isset($options['side_numposts']) && $options['side_numposts'] > 0 ? $options['side_numposts'] : "20";
    $query = db::query("SELECT p.*,u.`name`,u.`type`,u.`gender`,pr.`avatar`,o.`id` AS online FROM `{prefix}profile_posts` p LEFT JOIN `{prefix}users` u ON u.`id`=p.`userid` LEFT JOIN `{prefix}profiles` pr ON pr.`id`=p.`userid` LEFT JOIN `{prefix}onlines` o ON o.`id`=p.`userid` ORDER BY `id` DESC LIMIT 0,{$limit}");
    while ($row = mysqli_fetch_array($query, MYSQLI_ASSOC)) {
        if (in_array($row['userid'], $users)) {
            continue;
        }
        $avatar = '/avatars/' . (is_file('theme/images/avatars/' . $row['avatar']) ? $row['avatar'] : ($row['gender'] == '1' ? 'no_avatar_male.png' : 'no_avatar_female.jpg')) . '/100x100';
        $on = $row['online'] ? 'on' : 'off';
        $time = time_ago($row['time']);
        $users[] = $row['userid'];
        $lastposts[] = array(
            'id' => $row['userid'],
            'name' => $row['name'],
            'avatar' => $avatar,
            'type' => $row['type'],
            'online' => $on,
            'time' => $time,
            'rtime' => $row['time']
        );
        $x++;
    }
    unset($users, $x);
    mysqli_free_result($query);
    return $lastposts;
}
